'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx append.n
'\" 
.so man.macros
.TH "::listx append" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx append \- Append list elements onto a variable
.SH "SYNOPSIS"
\fB ::listx append \fIvarName\fR ?\fIvalue\fR...?
.BE
.SH "DESCRIPTION"
.PP
This command treats the variable given by \fIvarName\fR as a list and
appends each of the \fIvalue\fR arguments to that list as a separate
element, with spaces between elements.  If \fIvarName\fR doesn't
exist, it is created as a list with elements given by the \fIvalue\fR
arguments.  This subcommand is similar to the string based
\fBappend\fR except that the \fIvalue\fRs are appended as list elements
rather than raw text.  This command provides a relatively efficient
way to build up large lists.  For example,
``\fB::listx append a $b\fR''
is much more efficient than
``\fBset a [concat $a [list $b]]\fR'' when \fB$a\fR is long.
.SH "EXAMPLES"
.CS

.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
append, element, list, variable
