'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx assign.n
'\" 
.so man.macros
.TH "::listx assign" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx assign \- Assigning list elements to variables
.SH "SYNOPSIS"
\fB ::listx assign \fIlist\fR ?\fIvarname\fR?...
.BE
.SH "DESCRIPTION"
.PP
The subcommand \fBassign\fR takes a \fIlist\fR and zero or more variable
names as arguments. The first \fBn\fR elements of the list are
assigned to the \fBn\fR variables.
.PP
If there are more variables than elements in the list the
empty string will be assigned to the superfluous variables.
.PP
If there are more elements in the list than variable names specified
the command returns a list containing the unassigned elements.  Else
an empty list is returned.
.SH "EXAMPLES"
.CS
tclsh> ::listx assign {a b c d e} foo bar
c d e
tclsh> set foo
a
tclsh> set bar
b
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
list, assignment, variables
