'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx create.n
'\" 
.so man.macros
.TH "::listx create" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx create \- Create a list
.SH "SYNOPSIS"
\fB ::listx create \fIlist\fR ?\fIarg\fR...?
.BE
.SH "DESCRIPTION"
.PP
This subcommand returns a list comprised of all the \fIarg\fRs,
or an empty string if no \fIarg\fRs are specified.
Braces and backslashes get added as necessary, so that the \fBindex\fR subcommand
may be used on the result to re-extract the original arguments, and also
so that \fBeval\fR may be used to execute the resulting list, with
\fIarg1\fR comprising the command's name and the other \fIarg\fRs comprising
its arguments.  This subcommand produces slightly different results than
\fBconcat\fR:  \fBconcat\fR removes one level of grouping before forming
the list, while \fBcreate\fR works directly from the original arguments.
See the examples section for the differences.
.SH "EXAMPLES"
.CS
tclsh> ::listx create a b {c d e} {f {g h}}
a b {c d e} {f {g h}}

tclsh> ::listx concat a b {c d e} {f {g h}}
a b c d e f {g h}
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
element, list
