'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx filter.n
'\" 
.so man.macros
.TH "::listx filter" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx filter \- Searching through lists
.SH "SYNOPSIS"
\fB ::listx filter \fR?\fIoptions\fR? \fIlist\fR \fIpattern\fR
.BE
.SH "DESCRIPTION"
.PP
This command searches the \fIlist\fR for elements matching the
\fIpattern\fR and returns a new list containing these elements.
It is a convenience command combining both \fBsearch\fR and
\fBindex\fR.
.PP
The command recognizes the same options as \fBsearch\fR.
.SH "EXAMPLES"
.CS
tclsh> ::listx filter -exact {a b a f a b e} f
f
tclsh> ::listx filter -all -exact {a b a f a b e} a
a a a
tclsh> ::listx filter -not -exact {a b a f a b e} a
b
tclsh> ::listx filter -not -all -exact {a b a f a b e} a
b f b e
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
list, searching, filtering
