'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx flatten.n
'\" 
.so man.macros
.TH "::listx flatten" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx flatten \- Flattening lists
.SH "SYNOPSIS"
\fB ::listx flatten \fR?-full? ?--? \fIlist\fR
.BE
.SH "DESCRIPTION"
.PP
The subcommand \fBflatten\fR takes a single \fIlist\fR as argument
and returns a new list with one level of nesting removed from its. In
other words, sublists are replaced by their elements.
.PP
Using the option \fB-full\fR causes the command to remove any
nesting it finds from the input list.
.SH "EXAMPLES"
.CS
tclsh> ::listx flatten {1 2 3 {4 5} {6 7} {{8 9}} 10}
1 2 3 4 5 6 7 {8 9} 10
tclsh> ::listx flatten -full {1 2 3 {4 5} {6 7} {{8 9}} 10}
1 2 3 4 5 6 7 8 9 10
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
list, flattening
