'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx fold.n
'\" 
.so man.macros
.TH "::listx fold" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx fold \- Reducing a list into a single value
.SH "SYNOPSIS"
\fB ::listx fold \fIlist\fR \fIinitialvalue\fR \fIcmd\fR
.BE
.SH "DESCRIPTION"
.PP
The subcommand \fBfold\fR takes a \fIlist\fR, an arbitrary
\fIinitial value\fR and a command prefix (\fIcmd\fR) as its
arguments.  It expects that the specified command prefix (\fIcmd\fR)
is called with two arguments.  It reduces the list into a single value
through repeated application of the command prefix and returns that value.
.PP
The reduction is done by
.IP [1]
Application of the command to the initial value and the first element
of the list.
.IP [2]
Application of the command to the result of the last call and the
second element of the list.
.IP [...]
.IP [i]
Application of the command to the result of the last call and the i'th
element of the list.
.IP [...]
.IP [end]
Application of the command to the result of the last call and the last
element of the list. The result of this call is returned as the result
of the subcommand.
.SH "EXAMPLES"
.CS
tclsh> # summing the elements in a list.
tclsh> proc + {a b} {expr {$a + $b}}
tclsh> ::listx fold {1 2 3 4 5} 0 +
15
.CE
.SH "SEE ALSO"
listx(n), fold(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
list, folding, reduce
