'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx insert.n
'\" 
.so man.macros
.TH "::listx insert" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx insert \- Insert elements into a list
.SH "SYNOPSIS"
\fB ::listx insert \fIlist\fR \fIindex\fR \fIelement\fR ?\fIelement\fR...?
.BE
.SH "DESCRIPTION"
.PP
This subcommand produces a new list from \fIlist\fR by inserting all
of the \fIelement\fR arguments just before the \fIindex\fRth element
of \fIlist\fR.  Each \fIelement\fR argument will become a separate
element of the new list.  If \fIindex\fR is less than or equal to
zero, then the new elements are inserted at the beginning of the list.
If \fIindex\fR has the value \fBend\fR, or if it is greater than or
equal to the number of elements in the list, then the new elements are
appended to the list.  \fBend\fR-\fIinteger\fR refers to the last
element in the list minus the specified integer offset.
.SH "EXAMPLES"
.CS
tclsh> ::listx insert {a b c d} 1 foo
a foo b c d
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
element, insert, list
