'\" 
'\" Copyright (c) 2000 Andreas Kupries
'\" 
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) ::listx range.n
'\" 
.so man.macros
.TH "::listx range" n 8.2 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
::listx range \- Return one or more adjacent elements from a list
.SH "SYNOPSIS"
\fB ::listx range \fIlist\fR \fIfirst\fR \fIlast\fR
.BE
.SH "DESCRIPTION"
.PP
\fIList\fR must be a valid Tcl list.  This command will return a new
list consisting of elements \fIfirst\fR through \fIlast\fR, inclusive.
\fIFirst\fR or \fIlast\fR may be \fBend\fR (or any abbreviation of
it) to refer to the last element of the list.  If \fIfirst\fR is less
than zero, it is treated as if it were zero.  If \fIlast\fR is greater
than or equal to the number of elements in the list, then it is
treated as if it were \fBend\fR.  If \fIfirst\fR is greater than
\fIlast\fR then an empty string is returned.
Note: ``\fB::listx range\fR \fIlist first first\fR'' does not
always produce the same result as
``\fB::listx index\fR \fIlist first\fR'' (although it often does
for simple fields that aren't enclosed in braces); it does, however,
produce exactly the same results as
``\fB::listx create [::listx index\fR \fIlist first\fR\fB]\fR''
.SH "EXAMPLES"
.CS
tclsh> ::listx range {a b c d e} 2 4
c d e
.CE
.SH "SEE ALSO"
listx(n)
.SH "CREDITS"
.PP
.SH "KEYWORDS"
element, list, range, sublist
