/*
 * listxDecls.h --
 *
 *	Declarations of functions in the platform independent public Listx API.
 *
 * Copyright (c) 1999 by Andreas Kupries <a.kupries@westend.com>
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * RCS: @(#) $Id: listxDecls.h,v 1.2 2000/01/14 23:44:16 aku Exp $
 */

#ifndef _LISTXDECLS
#define _LISTXDECLS

/*
 * WARNING: This file is automatically generated by the tools/genStubs.tcl
 * script.  Any modifications to the function declarations below should be made
 * in the generic/listx.decls script.
 */

/* !BEGIN!: Do not edit below this line. */

/*
 * Exported function declarations:
 */

/* 0 */
EXTERN Tcl_Obj*		Listx_NewSelectorObj _ANSI_ARGS_((
				listSelector* CONST ls));
/* 1 */
EXTERN int		Listx_GetSelectorFromObj _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* obj, 
				listSelector** ls));
/* 2 */
EXTERN int		Listx_Search _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, Tcl_Obj* patternObj, 
				long int offset, lSearchModes mode, 
				int inverted, int nocase, int all, 
				listSelector* ls));
/* 3 */
EXTERN int		Listx_SelectSFromList _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				listSelector* CONST ls, Tcl_Obj** resultObj));
/* 4 */
EXTERN int		Listx_SelectSFromListByObj _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				Tcl_Obj* selectorObj, Tcl_Obj** resultObj));
/* 5 */
EXTERN int		Listx_SelectMFromList _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				int lsc, listSelector** CONST lsv, 
				Tcl_Obj** resultObj));
/* 6 */
EXTERN int		Listx_SelectMFromListByObj _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				int soc, Tcl_Obj** sov, Tcl_Obj** resultObj));
/* 7 */
EXTERN int		Listx_RemoveSFromList _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				listSelector* CONST ls, Tcl_Obj** resultObj));
/* 8 */
EXTERN int		Listx_RemoveSFromListByObj _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				Tcl_Obj* selectorObj, Tcl_Obj** resultObj));
/* 9 */
EXTERN int		Listx_RemoveMFromList _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				int lsc, listSelector** CONST lsv, 
				Tcl_Obj** resultObj));
/* 10 */
EXTERN int		Listx_RemoveMFromListByObj _ANSI_ARGS_((
				Tcl_Interp* interp, Tcl_Obj* listObj, 
				int soc, Tcl_Obj** sov, Tcl_Obj** resultObj));
/* Slot 11 is reserved */
/* Slot 12 is reserved */
/* Slot 13 is reserved */
/* Slot 14 is reserved */
/* Slot 15 is reserved */
/* Slot 16 is reserved */
/* Slot 17 is reserved */
/* Slot 18 is reserved */
/* Slot 19 is reserved */
/* 20 */
EXTERN int		Listx_Map _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, Listx_MapProc* mapProc, 
				ClientData clientData, Tcl_Obj** resultObj));
/* 21 */
EXTERN int		Listx_Fold _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, Tcl_Obj* initialObj, 
				Listx_FoldProc* foldProc, 
				ClientData clientData, Tcl_Obj** resultObj));
/* Slot 22 is reserved */
/* Slot 23 is reserved */
/* Slot 24 is reserved */
/* Slot 25 is reserved */
/* Slot 26 is reserved */
/* Slot 27 is reserved */
/* Slot 28 is reserved */
/* Slot 29 is reserved */
/* 30 */
EXTERN int		Listx_Split _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, int group, int stride, 
				Tcl_Obj** resultObj));
/* 31 */
EXTERN int		Listx_Merge _ANSI_ARGS_((Tcl_Interp* interp, 
				int listc, Tcl_Obj* CONST* listv, int group, 
				Tcl_Obj** resultObj));
/* Slot 32 is reserved */
/* Slot 33 is reserved */
/* Slot 34 is reserved */
/* Slot 35 is reserved */
/* Slot 36 is reserved */
/* Slot 37 is reserved */
/* Slot 38 is reserved */
/* Slot 39 is reserved */
/* 40 */
EXTERN int		Listx_Empty _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, int* emptyPtr));
/* 41 */
EXTERN int		Listx_Reverse _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, Tcl_Obj** resultObj));
/* 42 */
EXTERN int		Listx_ReverseInPlace _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj));
/* 43 */
EXTERN int		Listx_Flatten _ANSI_ARGS_((Tcl_Interp* interp, 
				Tcl_Obj* listObj, int full, 
				Tcl_Obj** resultObj));

typedef struct ListxStubHooks {
    struct ListxIntStubs *listxIntStubs;
} ListxStubHooks;

typedef struct ListxStubs {
    int magic;
    struct ListxStubHooks *hooks;

    Tcl_Obj* (*listx_NewSelectorObj) _ANSI_ARGS_((listSelector* CONST ls)); /* 0 */
    int (*listx_GetSelectorFromObj) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* obj, listSelector** ls)); /* 1 */
    int (*listx_Search) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Tcl_Obj* patternObj, long int offset, lSearchModes mode, int inverted, int nocase, int all, listSelector* ls)); /* 2 */
    int (*listx_SelectSFromList) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, listSelector* CONST ls, Tcl_Obj** resultObj)); /* 3 */
    int (*listx_SelectSFromListByObj) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Tcl_Obj* selectorObj, Tcl_Obj** resultObj)); /* 4 */
    int (*listx_SelectMFromList) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int lsc, listSelector** CONST lsv, Tcl_Obj** resultObj)); /* 5 */
    int (*listx_SelectMFromListByObj) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int soc, Tcl_Obj** sov, Tcl_Obj** resultObj)); /* 6 */
    int (*listx_RemoveSFromList) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, listSelector* CONST ls, Tcl_Obj** resultObj)); /* 7 */
    int (*listx_RemoveSFromListByObj) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Tcl_Obj* selectorObj, Tcl_Obj** resultObj)); /* 8 */
    int (*listx_RemoveMFromList) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int lsc, listSelector** CONST lsv, Tcl_Obj** resultObj)); /* 9 */
    int (*listx_RemoveMFromListByObj) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int soc, Tcl_Obj** sov, Tcl_Obj** resultObj)); /* 10 */
    void *reserved11;
    void *reserved12;
    void *reserved13;
    void *reserved14;
    void *reserved15;
    void *reserved16;
    void *reserved17;
    void *reserved18;
    void *reserved19;
    int (*listx_Map) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Listx_MapProc* mapProc, ClientData clientData, Tcl_Obj** resultObj)); /* 20 */
    int (*listx_Fold) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Tcl_Obj* initialObj, Listx_FoldProc* foldProc, ClientData clientData, Tcl_Obj** resultObj)); /* 21 */
    void *reserved22;
    void *reserved23;
    void *reserved24;
    void *reserved25;
    void *reserved26;
    void *reserved27;
    void *reserved28;
    void *reserved29;
    int (*listx_Split) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int group, int stride, Tcl_Obj** resultObj)); /* 30 */
    int (*listx_Merge) _ANSI_ARGS_((Tcl_Interp* interp, int listc, Tcl_Obj* CONST* listv, int group, Tcl_Obj** resultObj)); /* 31 */
    void *reserved32;
    void *reserved33;
    void *reserved34;
    void *reserved35;
    void *reserved36;
    void *reserved37;
    void *reserved38;
    void *reserved39;
    int (*listx_Empty) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int* emptyPtr)); /* 40 */
    int (*listx_Reverse) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, Tcl_Obj** resultObj)); /* 41 */
    int (*listx_ReverseInPlace) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj)); /* 42 */
    int (*listx_Flatten) _ANSI_ARGS_((Tcl_Interp* interp, Tcl_Obj* listObj, int full, Tcl_Obj** resultObj)); /* 43 */
} ListxStubs;

#ifdef __cplusplus
extern "C" {
#endif
extern ListxStubs *listxStubsPtr;
#ifdef __cplusplus
}
#endif

#if defined(USE_LISTX_STUBS) && !defined(USE_LISTX_STUB_PROCS)

/*
 * Inline function declarations:
 */

#ifndef Listx_NewSelectorObj
#define Listx_NewSelectorObj \
	(listxStubsPtr->listx_NewSelectorObj) /* 0 */
#endif
#ifndef Listx_GetSelectorFromObj
#define Listx_GetSelectorFromObj \
	(listxStubsPtr->listx_GetSelectorFromObj) /* 1 */
#endif
#ifndef Listx_Search
#define Listx_Search \
	(listxStubsPtr->listx_Search) /* 2 */
#endif
#ifndef Listx_SelectSFromList
#define Listx_SelectSFromList \
	(listxStubsPtr->listx_SelectSFromList) /* 3 */
#endif
#ifndef Listx_SelectSFromListByObj
#define Listx_SelectSFromListByObj \
	(listxStubsPtr->listx_SelectSFromListByObj) /* 4 */
#endif
#ifndef Listx_SelectMFromList
#define Listx_SelectMFromList \
	(listxStubsPtr->listx_SelectMFromList) /* 5 */
#endif
#ifndef Listx_SelectMFromListByObj
#define Listx_SelectMFromListByObj \
	(listxStubsPtr->listx_SelectMFromListByObj) /* 6 */
#endif
#ifndef Listx_RemoveSFromList
#define Listx_RemoveSFromList \
	(listxStubsPtr->listx_RemoveSFromList) /* 7 */
#endif
#ifndef Listx_RemoveSFromListByObj
#define Listx_RemoveSFromListByObj \
	(listxStubsPtr->listx_RemoveSFromListByObj) /* 8 */
#endif
#ifndef Listx_RemoveMFromList
#define Listx_RemoveMFromList \
	(listxStubsPtr->listx_RemoveMFromList) /* 9 */
#endif
#ifndef Listx_RemoveMFromListByObj
#define Listx_RemoveMFromListByObj \
	(listxStubsPtr->listx_RemoveMFromListByObj) /* 10 */
#endif
/* Slot 11 is reserved */
/* Slot 12 is reserved */
/* Slot 13 is reserved */
/* Slot 14 is reserved */
/* Slot 15 is reserved */
/* Slot 16 is reserved */
/* Slot 17 is reserved */
/* Slot 18 is reserved */
/* Slot 19 is reserved */
#ifndef Listx_Map
#define Listx_Map \
	(listxStubsPtr->listx_Map) /* 20 */
#endif
#ifndef Listx_Fold
#define Listx_Fold \
	(listxStubsPtr->listx_Fold) /* 21 */
#endif
/* Slot 22 is reserved */
/* Slot 23 is reserved */
/* Slot 24 is reserved */
/* Slot 25 is reserved */
/* Slot 26 is reserved */
/* Slot 27 is reserved */
/* Slot 28 is reserved */
/* Slot 29 is reserved */
#ifndef Listx_Split
#define Listx_Split \
	(listxStubsPtr->listx_Split) /* 30 */
#endif
#ifndef Listx_Merge
#define Listx_Merge \
	(listxStubsPtr->listx_Merge) /* 31 */
#endif
/* Slot 32 is reserved */
/* Slot 33 is reserved */
/* Slot 34 is reserved */
/* Slot 35 is reserved */
/* Slot 36 is reserved */
/* Slot 37 is reserved */
/* Slot 38 is reserved */
/* Slot 39 is reserved */
#ifndef Listx_Empty
#define Listx_Empty \
	(listxStubsPtr->listx_Empty) /* 40 */
#endif
#ifndef Listx_Reverse
#define Listx_Reverse \
	(listxStubsPtr->listx_Reverse) /* 41 */
#endif
#ifndef Listx_ReverseInPlace
#define Listx_ReverseInPlace \
	(listxStubsPtr->listx_ReverseInPlace) /* 42 */
#endif
#ifndef Listx_Flatten
#define Listx_Flatten \
	(listxStubsPtr->listx_Flatten) /* 43 */
#endif

#endif /* defined(USE_LISTX_STUBS) && !defined(USE_LISTX_STUB_PROCS) */

/* !END!: Do not edit above this line. */

#endif /* _LISTXDECLS */

