# -*- tcl -*-
#		Listx @mFullVersion@, as of @mDate@
#
# @c Sub command to filter a list by a pattern.

proc ::listx::filter {args} {
    # args = option... list pattern

    set            list [::listx index $args end-1]
    set fail [catch {
	::listx index $list [eval [linsert $args 0 ::listx search -all]]
    } res] ; # {}

    # possible results
    # 0 - ok,       nothing
    # 1 - error,    reflect up, use 'filter' in message instead of 'search'.

    if {$fail} {
	global errorInfo errorCode

	regsub -all search    $res filter res
	regsub -all \\.\\.\\. $res {}     res

	return  -code      error \
		-errorinfo $errorInfo \
		-errorcode $errorCode $res
    }

    return $res
}
