# -*- tcl -*-
#		Listx @mFullVersion@, as of @mDate@
#
# @c Sub commands to create long lists from a single element.

proc ::listx::repeat {elem count} {

    # This variant is significantly faster than the usual for-loop.
    # 'concat' is our saviour here.

    if {$count <= 0} {
	# No replication required

	return {}
    } elseif {$count == 1} {
	# Quick exit for recursion

	::listx create $elem
    } elseif {$count == 2} {
	# Another quick exit for recursion

	::listx create $elem $elem

    } elseif {0 == ($count % 2)} {
	# Halving the problem results in O (log n) complexity.

	set res [::listx repeat $elem [expr {$count / 2}]]
	::listx concat $res $res
    } else {

	set res [::listx repeat $elem [incr count -1]]
	::listx concat [::listx create $elem] $res
    }
}
